#include <sourcemod>

Handle g_iTimer;

public void OnPluginStart()
{
	HookEvent("round_start", 			Event_RoundStart, 		EventHookMode_PostNoCopy);
	HookEvent("round_end", 				Event_RoundEnd, 		EventHookMode_PostNoCopy);
}

public void Event_RoundStart(Event event, const char[] name, bool dontBroadcast)
{
	// let's start repeatable timer on each round start

	delete g_iTimer; // prevent double-run (just in case)
	
	// do not put here TIMER_FLAG_NO_MAPCHANGE !!! 
    // because handle variable will not be zeroed 
	g_iTimer = CreateTimer(1.0, Timer_Sample, _, TIMER_REPEAT);
}

public void Event_RoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	delete g_iTimer;
	// "delete" keyword automatically assign null with variable. 
    // Notice: delete 0 will not raise an exception.
}

public void OnMapEnd() // required, because ForceChangeLevel doesn't cause "round_end" event
{
	delete g_iTimer;
}

public Action Timer_Sample(Handle timer)
{
	// do something
	PrintToChatAll("tick");
	
	return Plugin_Continue;
	
	/* 
	Notice 1: if you want forcibly stop timer here, you have to zero handle's variable firstly
	
	g_iTimer = null;
	return Plugin_Stop;
	
	Notice 2: Never try to delete or KillTimer() within this timer callback itself.
	*/
}