/*
	This sample demonstrates 'Slapping player' after 30.0 sec delay on round start and repeat each 2 seconds until round ends.
	
	Thanks to Marttt for idea and code.
*/

#pragma semicolon 1
#pragma newdecls required

#include <sourcemod>
#include <sdktools>

#define WAIT_TIME 30.0

float g_fRoundStartTime;

public void OnPluginStart()
{
	HookEvent("round_start", 			Event_RoundStart, 		EventHookMode_PostNoCopy);
	HookEvent("round_end", 				Event_RoundEnd, 		EventHookMode_PostNoCopy);
	
	// starts the timer than will never be destroed
	CreateTimer(2.0, Timer_CheckPlayerZone, _, TIMER_REPEAT);
}

public Action Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	g_fRoundStartTime = GetEngineTime();
}

public Action Event_RoundEnd(Handle event, const char[] name, bool dontBroadcast)
{
	g_fRoundStartTime = 0.0;
}

public void OnMapEnd()
{
	g_fRoundStartTime = 0.0;
}

public Action Timer_CheckPlayerZone(Handle timer)
{
	if ( g_fRoundStartTime == 0.0 ) // pause timer between "round_end" - "round_start" events
		return Plugin_Continue;
	
	if ( GetEngineTime() - g_fRoundStartTime < WAIT_TIME ) // pause timer within 30.0 sec interval after "round_start"
		return Plugin_Continue;
	
	for ( int i = 1; i <= MaxClients; i++ )
	{
		if ( IsClientInGame(i) && IsPlayerAlive(i) )
		{
			SlapPlayer(i, 20, true);
			PrintToChat(i, "You are being slapped!");
		}
	}
	return Plugin_Continue;
}