#include <sourcemod>

Handle g_iTimer; // our global timer's variable

public void OnPluginStart()
{
	HookEvent("round_start", 			Event_RoundStart, 		EventHookMode_PostNoCopy);
	HookEvent("round_end", 				Event_RoundEnd, 		EventHookMode_PostNoCopy);
}

// let's create timer when round starts:

public void Event_RoundStart(Event event, const char[] name, bool dontBroadcast)
{
	delete g_iTimer; // delete previous timer in case "round_start" fired twice
	
	g_iTimer = CreateTimer(30.0, Timer_Sample);
	
	// do not put here TIMER_FLAG_NO_MAPCHANGE !!! 
    // because handle's variable will not be zeroed automatically in case map change happens before timer is fired
}

public void Event_RoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	delete g_iTimer; // stop timer if it is not fired yet, so this timer will not fire on the next round or between level load
	
	// "delete" keyword stops the timer and automatically assign null with variable.
    // Notice: delete 0 will not raise an exception.
}

public void OnMapEnd() // required, because forcible change level doesn't fire "round_end" event
{
	delete g_iTimer;
}

public Action Timer_Sample(Handle timer)
{
	//do something
	PrintToChatAll("tick");

	// do not forget to zero timer's handle here, because after callback finishes, timer's handle become invalid
	g_iTimer = null;
}
