#include <sourcemod>

Handle g_iTimer[MAXPLAYERS+1];

public void OnPluginStart()
{
	HookEvent("round_start", 			Event_RoundStart, 		EventHookMode_PostNoCopy);
	HookEvent("round_end", 				Event_RoundEnd, 		EventHookMode_PostNoCopy);
	
	RegConsoleCmd("sm_timer", CmdTestTimer, "Re-starts timer for testing")
}

Action CmdTestTimer(int client, int args)
{
	delete g_iTimer[client];
	g_iTimer[client] = CreateTimer(15.0, Timer_Sample, GetClientUserId(client));
}

public void Event_RoundStart(Event event, const char[] name, bool dontBroadcast)
{
	for ( int i = 1; i <= MaxClients; i++ )
	{
		if ( IsClientInGame(i) )
		{
			// start single per-client timer
			delete g_iTimer[i];
			g_iTimer[i] = CreateTimer(3600.0, Timer_Sample, GetClientUserId(i));
		}
	}
}

public void OnClientDisconnect(int client)
{
	delete g_iTimer[client];
}

void Reset()
{
	for ( int i = 1; i <= MaxClients; i++ )
	{
		delete g_iTimer[i];
	}
}

public void Event_RoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	Reset();
}

public void OnMapEnd()
{
	Reset();
}

public Action Timer_Sample(Handle timer, int UserId)
{
	int client = GetClientOfUserId(UserId);
	
	if ( client && IsClientInGame(client) )
	{
		g_iTimer[client] = null;
		
		// do something
		// ...
		PrintToChat(client, "tick");
	}
}